{$M $4000,0,$49000}
{⮤ 㭣-}
Uses Crt,Dos,Paper,Graph,Fonts_p,Fonts;
Const mm:Byte=2; {Quantity of ethnoses}
      nEq=7;     {Quantity of equations}
      MaxEthn=8; {Max quantity of ethnoses}
      LimT=600;  {The time when decay begins}

Type Arr=Array[1..MaxEthn] of Real;
     Arr2=Array[1..MaxEthn] of Arr;
     SChar=Set of Char;
Type Vec=Array [1..nEq] Of Real;

Var  P, M, S, O, C, L, D,
    oP,oM,oS,oO,oC,oL,oD,odPi :Arr;
    tP,odP:Arr;
    t:Real; {Time}
    h:Real; {Step}
    Nn:Real; {Coeff. of population growth}
    n0:Real; {The population at the time 0}

    Ch:Char;
    i,jj,j:Byte;
    Scale:Word;
    ScaleT:Word;
    Enabled:Array[1..nEq+1] of Boolean;
    NextWind,TmpWind,PrevWind:Byte;
    x,ox:Vec;
Const LegendNames:Array[1..8] of String[30]=(
      'Passionarians',
      'Subpassionarians',
      'Harmonius people',
      'State',
      'Science',
      'Art',
      'Landscape',
      'Pass. intensity');

{$I new_mod.inc}
{$I New_EQ.pas}
{$I New_Tool.pas}

Procedure LoadConst;
Var f:Text;ss:String; i:Byte;
    len:Byte; n:Word; Warn:Word;
    Cons:String;

Procedure Warning(st:String);
Begin
  Inc(Warn);
  Writeln('Line No ',n,': ',st);
End;
Procedure Skip;
Begin
  Inc(i);
  While (ss[i] in [' ',#9])and(i<=Len) do Inc(i);
End;
Procedure ReadWord(Var st:String;ee:SChar);
Begin
  St:='';
  While (not (ss[i] in [' ',#9]+ee))and(i<=Len) do Begin
    St:=St+ss[i]; Inc(i);
  End;
End;
Function ReadReal:Real;
Var St:String;Rea:Real;er:Integer;
Begin
  Skip; ReadWord(St,[]);
  Rea:=0;
  Val(St,Rea,er);
  If er<>0 then Warning('Wring number '+St);
  ReadReal:=Rea;
End;
Procedure ReadArr(Var v:Arr);
Var k:Byte;
Begin
  For k:=1 to mm do v[k]:=ReadReal;
  Skip;
End;
Procedure ReadArr2(Var v:Arr2);
Var k:Byte;
Begin
  For k:=1 to mm do Begin
     ReadArr(v[k]);
     If k<mm then Begin
      If Eof(f) then Warning('Unexpected end of file.')
      else Begin
       Repeat
	 ReadLn(f,ss);
	 i:=1; Len:=Length(ss);Inc(n);
       Until (Len>0)and(ss[1]<>'-');
      End;
     End;
  End;
End;

Begin
  n:=1; Warn:=0;
  Assign(f,'New_Mod.cf');
  ReSet(f);
  While not Eof(f) do Begin
    ReadLn(f,ss); Len:=Length(ss);
    If (Len>0)and(ss[1]<>'-') then Begin
       i:=1;
       While (i<=Len)and(ss[i]<>':') do Inc(i);
       If i>Len
       then Warning('Symbol ":" not found')
       else Begin
	 Skip;
	 ReadWord(Cons,['=']);
	 If Cons='KPii' then ReadArr(KPii)
	 else If Cons='KPm' then ReadArr(KPm)
	 else If Cons='KPsp' then ReadArr(KPsp)
	 else If Cons='KPsm' then ReadArr(KPsm)
	 else If Cons='KPo' then ReadArr(KPo)
	 else If Cons='KPe' then ReadArr(KPe)
	 else If Cons='KPp' then ReadArr(KPp)
	 else If Cons='KPl' then ReadArr(KPl)
	 else If Cons='KPc' then ReadArr(KPc)

	 else If Cons='KSii' then ReadArr(KSii)

	 else If Cons='KMii' then ReadArr(KMii)
	 else If Cons='KMo' then ReadArr(KMo)
	 else If Cons='KMl' then ReadArr(KMl)
	 else If Cons='KMp' then ReadArr(KMp)

	 else If Cons='KOm' then ReadArr(KOm)
	 else If Cons='KOt1' then ReadArr(KOt1)
	 else If Cons='KOt2' then ReadArr(KOt2)
	 else If Cons='KOc1' then ReadArr(KOc1)
	 else If Cons='KOc2' then ReadArr(KOc2)

	 else If Cons='KLo' then ReadArr(KLo)
	 else If Cons='KLc' then ReadArr(KLc)

	 else If Cons='P0' then ReadArr(P0)
	 else If Cons='O0' then ReadArr(O0)
	 else If Cons='O1' then ReadArr(O1)

	 else If Cons='KPw' then ReadArr2(KPw)
	 else If Cons='KPt' then ReadArr2(KPt)
	 else If Cons='KSw' then ReadArr2(KSw)
	 else If Cons='KMt' then ReadArr2(KMt)
	 else If Cons='KMc' then ReadArr2(KMc)
	 else If Cons='KMw' then ReadArr2(KMw)
	 else If Cons='KOwop' then ReadArr2(KOwop)
	 else If Cons='KOwom' then ReadArr2(KOwom)
	 else If Cons='KCc' then ReadArr2(KCc)

	 else If Cons='P' then ReadArr(oP)
	 else If Cons='S' then ReadArr(oS)
	 else If Cons='M' then ReadArr(oM)
	 else If Cons='O' then ReadArr(oO)
	 else If Cons='T' then ReadArr(oD)
	 else If Cons='C' then ReadArr(oC)
	 else If Cons='L' then ReadArr(oL)
         else If Cons='dP' then ReadArr(odPi)

	 else If Cons='m' then mm:=Round(ReadReal)
	 else If Cons='Nn' then Nn:=ReadReal
	 else If Cons='n0' then n0:=ReadReal
	 else Warning('Wrong constant '+Cons);
       End;
    End;
    Inc(n);
  End;
  Close(f);
  If Warn>0 then ch:=ReadKey;
End;

Function WaitNextWindow:Byte;
Var c:Char;
Begin
     Repeat
      c:=ReadKey;
      If c<>#27 then
	 If c<>#0 then c:='_'
		  else c:=ReadKey;
     Until c in [#27,';'..'D'];
     If c=#27 then WaitNextWindow:=PrevWind
	      else WaitNextWindow:=21+Ord(c)-Ord(';');
End;

Function Enabl:Byte;
Var c:Char; i,j:Integer;

Procedure DrawArrow;
Var ee:Integer;
Begin
    SetLineStyle(0,0,1);
    ee:=(j div abs(j));
    MoveTo((267 div 2)-j,i*13);
    LineRel(ee*8,0);
    LineRel(-ee*3,-2);LineRel(ee*3,2);
    LineRel(-ee*3,2);
    SetLineStyle(0,0,3);
End;

Procedure Show;
Begin
   SetColor(15);
   DrawArrow;
End;

Procedure Hide;
Begin
   SetColor(8);
   DrawArrow;
End;
Procedure DrawColorLines;
Var i:Integer;
Begin
  For i:=1 to 8 do Begin
      If Enabled[i] then Begin If i=8 then SetColor(1)
                                      else SetColor(16-i)
                         End
		    else SetColor(8);
	 Line(7+5,i*13,37+5,i*13);
  End;
End;

Begin
  Window(30,320,227,120,8,'Legend',Gr_Col,WS_PopUp);
  SetTextStyle(0,0,1);SetLineStyle(0,0,3);
  DrawColorLines;
  SetColor(15);
  For i:=1 to 8 do Begin
      OutTextXY(45+5,i*13-4,LegendNames[i]);
  End;
  i:=1; j:=(267 div 2)-2;
  Repeat
  Show;
  c:=ReadKey;
  If c=' ' then Begin
     Enabled[i]:=Not Enabled[i];
     DrawColorLines;
  End;
  If c=#0 then Begin
     c:=ReadKey;
     Hide;
     Case c of
       'H':If i=1 then i:=8 else Dec(i);
       'P':i:=(i mod 8)+1;
     End;
  End;
  Until c in [#13,#27,#59..#68];
  SetLineStyle(0,0,1);
  If c in [#27,#13] then Enabl:=PrevWind
		    else Enabl:=21+Ord(c)-Ord(';');
  Window(30,320,227,120,8,'Legend',Gr_Col,WS_Off);
End;

Const Fu:Array[1..nEq] of Function(i:Byte):Real=
      (ddP,ddS,ddM,ddO,ddT,ddC,ddL);
      Var_:Array[1..nEq] of ^Vec=(@P,@S,@M,@O,@D,@C,@L);

Var K1,K2,K3,K4,Tmp:Array[1..14] of Real;

Procedure DottedLineX(x1,x2,y:Integer);
Var i:Integer;
Begin
  For i:=0 to (x2-x1)div 10 do Paper.PutPixel(x1+i*10,y,1);
End;
Procedure DottedLineY(x,y1,y2:Integer);
Var i:Integer;
Begin
  For i:=0 to (y2-y1)div 10 do Paper.PutPixel(x,y1+i*10,1);
End;

Procedure CreateWindow(x1,y1,x2,y2:Word);
Begin
  SetDefPrintPort;
  Paper.SetColor(0);
  Paper.Bar(x1,y1,x2,y2);
  Paper.SetColor(1);
  Paper.Rectangle(x1,y1,x2,y2);
  SetPrintPort(x1+2,y1+2,x2-2,y2-2);
End;


Function DrawResult(Koef:Real;Which:Byte):Byte;
Const ResultX=600;
      ResultY=370;
      ResY2=ResultY div 2;
      ResY=ResultY-20;
      MaxSiz=19;
      Sizes:array[1..MaxSiz] of real=( 0.001,0.002,0.005,
				   0.01, 0.02, 0.025,0.05,
				   0.1,  0.2,  0.25, 0.5,1,2,5,10,20,50,100,150);
      SizesT:Array[1..11] of Integer=(1,2,5,10,20,25,50,100,200,250,500);
      MinResT=30;
      MinRes=20;
Var i:Integer;sr,st:String;
    NumYdiv,siz,SizT:Byte;
    Koeff:Real; ks,ks1:Word; Prks:Boolean;
Begin
 P:=oP; S:=oS; M:=oM; O:=oO;
 C:=oC; D:=oD; L:=oL;
 Case Which of
   1: st:='The 1-st ethnos';
   2: st:='The 2-nd ethnos';
   3: st:='All the ethnoses';
 End;
 Window(20,40,ResultX,ResultY,8,'Result: '+st,Res_Col,WS_PopUp);
 SetLineStyle(1,0,1);SetColor(0);
 SetTextStyle(2,0,4);
 SizT:=1;

 SetDefPrintPort;
 ClearPaper;
 Fonts_p.LoadFont('serif18.fnt',True);
 Fonts_p.OutStringC(0,Paper.GetMaxX,2,'Evalution curves of '+St);
 SetThick(1);
 Paper.Rectangle(10,35,Paper.GetMaxX-5,30+Paper.GetMaxY div 2-5);
 SetPrintPort(12,37,Paper.GetMaxX-7,30+Paper.GetMaxY div 2-7);
 SetThick(0);

 While SizesT[SizT]/ScaleT*ResultX<MinResT do Inc(SizT);
 Fonts_p.LoadFont('sserif12.fnt',True);
 i:=1;
 While i<ScaleT/SizesT[SizT] do Begin
     SetLineStyle(1,0,1);
     SetColor(0);
     Line(Round(i*SizesT[SizT]/ScaleT*ResultX),0,Round(i*SizesT[SizT]/ScaleT*ResultX),ResultY);
     DottedLineY(Round(i*SizesT[SizT]/ScaleT*Paper.GetPortX),0,Paper.GetPortY);
     sr:=ToStrI(i*SizesT[SizT]);
     SetColor(7);
     SetLineStyle(0,0,1);
     OutTextXY(Round(i*SizesT[SizT]/ScaleT*ResultX)-TextWidth(sr) div 2,2,sr);
     Fonts_p.OutStringXY(Round(i*SizesT[SizT]/ScaleT*Paper.GetPortX)-Fonts_p.StrWidth(sr) div 2,2,sr);
     Inc(i);
 End;
 Siz:=1;
 Koef:=Koef/5;
 Koeff:=Koef/ResultY*Paper.GetPortY;
 While Sizes[Siz]*Koef<MinRes do Inc(Siz);
 NumYDiv:=Trunc((ResY-20)/Koef/Sizes[Siz]);
 For i:=0 to NumYdiv do Begin
     SetColor(0);
     SetLineStyle(1,0,1);
     Line(0,ResY-Round(i*Sizes[Siz]*Koef),ResultX,ResY-Round(i*Sizes[Siz]*Koef));
     DottedLineX(0,Paper.GetPortX,Paper.GetPortY-20-Round(i*Sizes[Siz]*Koeff));
     SetColor(7); sr:=ToStr(i*Sizes[Siz]);
     SetLineStyle(0,0,1);
     OutTextXY(ResultX-40,ResY-Round(i*Sizes[Siz]*Koef)-7,sr);
     Fonts_p.OutStringXY(Paper.GetPortX-40,Paper.GetPortY-20-Round(i*Sizes[Siz]*Koeff)-10,sr);
 End;

{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{}
 { To decrease the step, write a number greater than 4000 instead of 4000.}
 ks:=0;
 t:=0; h:=ScaleT/4000;
 For jj:=1 to mm do odP[jj]:=odPi[jj];
 For jj:=1 to 7 do ox[jj]:=0;

 While (t<=ScaleT)and(not KeyPressed) Do Begin
  For i:=1 to mm do tP[i]:=ddP(i);
  {For jj:=1 to mm do odP[jj]:=0;}

  For i:=1 to nEq do
    For j:=1 to mm do Tmp[(i-1)*mm+j]:=Var_[i]^[j];
  For i:=1 to nEq do
    For j:=1 to mm do K1[(i-1)*mm+j]:=h*Fu[i](j);

  t:=t+h/2;
  For i:=1 to nEq do
    For j:=1 to mm do Var_[i]^[j]:=Tmp[(i-1)*mm+j]+K1[(i-1)*mm+j]/2;
  For i:=1 to nEq do
    For j:=1 to mm do K2[(i-1)*mm+j]:=h*Fu[i](j);

  For i:=1 to nEq do
    For j:=1 to mm do Var_[i]^[j]:=Tmp[(i-1)*mm+j]+K2[(i-1)*mm+j]/2;
  For i:=1 to nEq do
    For j:=1 to mm do K3[(i-1)*mm+j]:=h*Fu[i](j);

  t:=t+h/2;
  For i:=1 to nEq do
    For j:=1 to mm do Var_[i]^[j]:=Tmp[(i-1)*mm+j]+K3[(i-1)*mm+j];
  For i:=1 to nEq do
    For j:=1 to mm do K4[(i-1)*mm+j]:=h*Fu[i](j);

  For i:=1 to nEq do
    For j:=1 to mm do Var_[i]^[j]:=Tmp[(i-1)*mm+j]+
     (K1[(i-1)*mm+j]+2*K2[(i-1)*mm+j]+2*K3[(i-1)*mm+j]+K4[(i-1)*mm+j])/6;

  For i:=1 to nEq do x[i]:=Var_[i]^[Which];
  For j:=1 to mm Do odP[j]:=tP[j];

		   { Counting of the passionarian intensity}

  ks1:=ks;
  ks:=Trunc(t/ScaleT*Paper.GetPortX);
  SetColor(1);
  If Enabled[8] then Begin
    Line(Trunc((t-h)/ScaleT*ResultX),ResY-Trunc((ox[1]+ox[2]+ox[3])*Koef/(Nn*t+n0)),
         Trunc(t/ScaleT*ResultX),ResY-Trunc((x[1]+x[2]+x[3])*Koef/(Nn*t+n0)));
    SetThick(2);
    {If ks>ks1 then}
      Paper.Line(ks1,Paper.GetPortY-20-Trunc((ox[1]+ox[2]+ox[3])*Koeff/(Nn*t+n0)),
                 ks,Paper.GetPortY-20-Trunc((x[1]+x[2]+x[3])*Koeff/(Nn*t+n0)));
  End;
  For i:=1 To 7 Do Begin
    If Enabled[i] then Begin SetColor(16-i);
     Line( Trunc((t-h)/ScaleT*ResultX),ResY-Trunc(ox[i]*Koef),
           Trunc(t/ScaleT*ResultX),ResY-Trunc(x[i]*Koef));
     If i>4 then SetThick(1)
            else SetThick(0);
     If ks>ks1 then Begin
       Case ((i-1) mod 4) of
         0: Prks:=True;
         1: Prks:=((ks mod 16) and 4)=0;
         2: Prks:=((ks mod 16) and 2)=0;
         3: Prks:=((ks mod 16) in [0..7,10..13]);
       End;
       If Prks then
           Paper.Line( ks1,Paper.GetPortY-20-Trunc(ox[i]*Koeff),
                       ks,Paper.GetPortY-20-Trunc(x[i]*Koeff));
     End;
    End;
    ox[i]:=x[i];
    {PutPixel(Trunc(t/MaxT*ResultX),ResY-Trunc(x[i]*Koef),16-i);
    PutPixel(Trunc(t/MaxT*ResultX),ResY-Trunc((x[1]+x[2]+x[3])*Koef),1);}
  End;
 End;
 DrawResult:=WaitNextWindow;
 Window(20,40,ResultX,ResultY,8,st,Res_Col,WS_Off);
End;


Function GetScale(Var Scale:Word):Byte;
Var scl:String; er:Integer; NxtWnd:Byte;
Begin
  Window(300,310,220,100,8,'Scale Y',Gr_Col,WS_PopUp);
  Scl:=ToStrI(Scale);
  er:=1;
  Repeat
    NxtWnd:=Ask(3,3,'Enter scale: ',Scl);
    Val(Scl,Scale,er);
  Until (er=0) and (NxtWnd in [0,21..30]);
  If NxtWnd=0 then GetScale:=PrevWind
	      else GetScale:=NxtWnd;
  Window(300,310,220,100,8,'Scale Y',Gr_Col,WS_Off);
End;

Function GetScaleT(Var ScaleT:Word):Byte;
Var scl:String; er:Integer; NxtWnd:Byte;
Begin
  Window(320,330,220,100,8,'Scale Time',Gr_Col,WS_PopUp);
  Scl:=ToStrI(ScaleT);
  er:=1;
  Repeat
    NxtWnd:=Ask(3,3,'Enter scale: ',Scl);
    Val(Scl,ScaleT,er);
  Until (er=0) and (NxtWnd in [0,21..30]);
  If NxtWnd=0 then GetScaleT:=PrevWind
	      else GetScaleT:=NxtWnd;
  Window(320,330,220,100,8,'Scale Time',Gr_Col,WS_Off);
End;

Function Help:Byte;
Var i,j:Byte;FntH:Byte;
Const HelpStr:array[1..10] of String[40]=
      ('Help (this text)',
       'Curves of the 1-st ethnos',
       'Curves of the 2-nd ethnos',
       '----{Passionarian intensities}',
       'Legend. Curves to be drawn',
       'Y Scale',
       'Time scale',
       'Print',
       'Constant editor',
       'Exit');

Begin
 Window(70,80,380,240,14,'Help',Res_Col,WS_PopUp);
 LoadFont('Sserif14.fnt',True);SetTextAttr(0,0);FntH:=FontHeight;
 SetColor(14);
 For i:=1 to 10 do OutStringXY(5,(i-1)*FntH,'F'+ToStrI(i));
 LoadFont('sserif10.fnt',True);SetTextAttr(F_Bold or F_Italic,4);
 SetColor(15);
 For i:=1 to 10 do OutStringXY(43,(i-1)*FntH+5,HelpStr[i]);
 Help:=WaitNextWindow;
 Window(70,80,380,240,14,'Help',Res_Col,WS_Off);
End;

Function PrintGraphics:Byte;
Var FntH,i:Byte; Prks:Boolean;
Begin
  Window(170,300,300,50,14,'Printing Graphics',Res_Col,WS_PopUp);
  LoadFont('Sserif12.fnt',True);SetTextAttr(0,0);FntH:=FontHeight;

 {Let's draw the legend}
  CreateWindow(40,65,300,65+168);
  Fonts_p.LoadFont('sserif12.fnt',True);
  For i:=1 to 8 do Begin
      Fonts_p.OutStringXY(70,i*18-9,LegendNames[i]);
      If i=8 then SetThick(2)
             else If i>4 then SetThick(1)
                         else SetThick(0);
      For j:=0 to 47 do Begin
        If i=8
           then Prks:=True
           else Case ((i-1) mod 4) of
            0: Prks:=True;
            1: Prks:=((j mod 16) and 4)=0;
            2: Prks:=((j mod 16) and 2)=0;
            3: Prks:=((j mod 16) in [0..7,10..13]);
           End;
        If Prks then Paper.Line(12+j,i*18,12+j,i*18);
      End;
  End;


  SetColor(14);
  OutStringXY(0,0,'Press <space> to pause');
  OutStringXY(0,FntH,'Press <Esc> to stop');

  PrintPaper3;
  Bar(0,0,300,50);
  OutStringXY(0,0,'Graphics printed.');
  PrintGraphics:=WaitNextWindow;
  Window(170,300,300,50,14,'Printing Graphics',Res_Col,WS_Off);
End;

Begin
  ClrScr;
  ChooseRes(2); ChoosePaper(1);
  InitPaper; ClearPaper;

 LoadConst;
 For i:=1 to 4 do Enabled[i]:=True;
 For i:=5 to 7 do Enabled[i]:=False;
 Enabled[8]:=True;
 Init;
 Set00;
 SetFillStyle(1,7);
 Bar(0,0,639,479);
 Scale:=70;
 ScaleT:=1200;
 NextWind:=Help;
 PrevWind:=NextWind;
 Repeat
   PrevWind:=TmpWind;
   TmpWind:=NextWind;
  Case NextWind of
   21: NextWind:=Help;
   22..24: NextWind:=DrawResult(Scale,NextWind-21);
   25: NextWind:=Enabl;
   26: NextWind:=GetScale(Scale);
   27: NextWind:=GetScaleT(ScaleT);
   28: NextWind:=PrintGraphics;
   29: Begin
	 CloseGraph;
	 SwapVectors;
	 Exec('e.exe','New_Mod.cf');
	 SwapVectors;
         if DosError <> 0 then Begin { Error? }
            WriteLn('Dos error #', DosError);
            Writeln('Free memory: ',MaxAvail);
            ch:=ReadKey;
         End;
         LoadConst; Init;
         SetFillStyle(1,7);
         Bar(0,0,639,479);
         PrevWind:=25;TmpWind:=25;
	 NextWind:=DrawResult(Scale,1);
       End;
   30:;
  else NextWind:=WaitNextWindow;
  End;
 Until NextWind in [30];
 CloseGraph;
 DonePaper;
End.