Unit Paper;
{PostScript - ᮢ    ᯥ⪠ ⮣}
InterFace
{ࠧ  dots}
Procedure PutPixel(x,y:Integer;c:Byte);
Procedure Line(x1,y1,x2,y2:Integer);
Procedure LineTo(x,y:Integer);
Procedure LineRel(x,y:Integer);
Function GetX:Integer;
Function GetY:Integer;
Function GetMaxX:Integer;
Function GetMaxY:Integer;
Function GetPortX:Integer;
Function GetPortY:Integer;
Function GetSizeX:Real;
Function GetSizeY:Real;
Procedure MoveTo(x,y:Integer);
Procedure MoveRel(x,y:Integer);
Procedure SetThick(n:Byte);
Procedure Bar(x1,y1,x2,y2:Integer);
Procedure Rectangle(x1,y1,x2,y2:Integer);
Procedure SetPrintPort(x1,y1,x2,y2:Integer);
Procedure SetDefPrintPort;
Procedure SetColor(c:Byte);
Function GetColor:Byte;

{ࠧ  cm}
Procedure PutPixelM(x,y:Real;c:Byte);
Procedure BarM(x1,y1,x2,y2:Real);
Procedure RectangleM(x1,y1,x2,y2:Real);
Procedure LineM(x1,y1,x2,y2:Real);
Procedure LineToM(x,y:Real);
Procedure LineRelM(x,y:Real);
Procedure MoveToM(x,y:Real);
Procedure MoveRelM(x,y:Real);
Procedure SetPrintPortM(x1,y1,x2,y2:Real);

Function GetDot(x,y:Integer):Byte;
Procedure PrintPaper;
Procedure PrintPaper1;
Procedure PrintPaper2;
Procedure PrintPaper3;
Procedure PrintPaper4;
Procedure PrintPaper144;
Procedure InitPaper;
Procedure DonePaper;
Procedure ClearPaper;
Procedure ChoosePaper(n:Byte);
Procedure SelectPaper(x,y:Real); { ࠭}
Procedure ChooseRes(n:Byte); {襭}

Implementation
Uses Tools,Printer,Crt;
Type PaperType=Record
                 x,y:Real; {ࠧ  ᠭ⨬}
                 name:String[40];
               End;
Const MaxPiece=19;
      Inch=2.54; {cm}
      dy=1.2; {cm}
      Papers:Array [1..3] of PaperType=(
        (x:20;y:28.7;name:'⠭'),
        (x:28.7;y:20;name:''),
        (x:14.3;y:20;name:''));
        {⠭ ࠧ ⮢  cm }

Type PaperPiece=Array[0..32767] of byte;
     pPaperPiece=^PaperPiece;
     PaperT=array[0..MaxPiece] of pPaperPiece;

Var Pap:PaperT;
    NPlan:Byte;
    xxx,yyy:Word;
    SizeX,SizeY:Real; {cm}
    i:Byte;
    px,py:Byte;{⭮  }
    PPx,PPy:Word; {PC coords}
    oUp,oDn,oLt,oRt:Word;{coords of PrintPort}
    cCol:Byte; {騩 梥}
    Thick:Byte; {Thickness of lines}
    Res:Byte;{No 襭}
    NPiece:Byte;
    {----}
    c:Char;

Procedure PutPixel(x,y:Integer;c:Byte);
Var np,ly,a,b:Byte;ty:Word;
Begin
 If (x>0)and(y>0) then Begin
   x:=x+oLt; y:=y+oUp;
   If (x<=oRt)and(y<=oDn) then Begin
     np:=y div (16*NPlan); { ᪠ 㬠}
     ty:=y mod (16*NPlan);
     ly:=ty mod 16;
     a:=ty div 16;
     b:=ly mod 2;
     If (c and 1)=1
        then Pap[np]^[(2*a+b)*xxx+x]:=Pap[np]^[(2*a+b)*xxx+x] or ($80 shr (ly shr 1))
        else Pap[np]^[(2*a+b)*xxx+x]:=Pap[np]^[(2*a+b)*xxx+x] and not ($80 shr (ly shr 1));
   End;
 End;
End;

Function GetDot(x,y:Integer):Byte;
Var np,ly,a,b:Byte;ty:Word;
Begin
 If (x>0)and(y>0) then Begin
   x:=x+oLt; y:=y+oUp;
   If (x<=oRt)and(y<=oDn) then Begin
      np:=y div (16*NPlan); { ᪠ 㬠}
      ty:=y mod (16*NPlan);
      ly:=ty mod 16;
      a:=ty div 16;
      b:=ly mod 2;
      If Pap[np]^[(2*a+b)*xxx+x] and ($80 shr (ly shr 1))>0
         then GetDot:=1
         else GetDot:=0;
   End;
 End;
End;

Procedure PrintPaper1;
Var n,i,j,k,s:Word; Maxn:Byte;
    c:Char;
Begin
  Write(Lst,#27'A'#8#27'2'); {⠭ ࢠ}
  Write(Lst,#27,'5',#0); {⪫祭 ⮯ॢ ப}
  n:=0; i:=0; c:='_'; Maxn:=(yyy-1) div 16;
  While (n<=5)and(c<>#27)and(n*nPlan+i<=Maxn) do Begin
    While (i<=NPlan-1)and(c<>#27)and(n*nPlan+i<=Maxn) do Begin
      Write(Lst,#27'*'#0,Char(xxx mod 256),Char(xxx div 256)); {Gr. reg.}
      For k:=0 to xxx-1 do Begin
          s:=0;
          For j:=0 to 7 do
              s:=(s shl 1)+GetDot(k,j+i*8);
          Write(Lst,Char(s));
      End;
      Writeln(Lst);
      If KeyPressed then c:=ReadKey;
      If c=' ' then Begin Repeat Until KeyPressed; c:=ReadKey; c:='_';End;
      Inc(i);
    End;
    i:=0;Inc(n);
  End;
End;

Procedure PrintPaper2;
Var n,i,j,k,s:Word; Maxn:Byte;
    c:Char;
Begin
  Write(Lst,#27'A'#8#27'2'); {⠭ ࢠ}
  Write(Lst,#27,'5',#0); {⪫祭 ⮯ॢ ப}
  n:=0; i:=0; c:='_'; Maxn:=(yyy-1) div 16;
  While (n<=5)and(c<>#27)and(n*nPlan+i<=Maxn) do Begin
    While (i<=NPlan-1)and(c<>#27)and(n*nPlan+i<=Maxn) do Begin
      Write(Lst,#27'*'#1,Char(xxx mod 256),Char(xxx div 256)); {Gr. reg.}
      For j:=0 to xxx-1 do Write(Lst,Char(Pap[n]^[i*xxx*2+j]));
      Write(Lst,#27,'J',#2,#13);  {2/216 + <CR> }
      Write(Lst,#27'*'#1,Char(xxx mod 256),Char(xxx div 256)); {Gr. reg.}
      For j:=0 to xxx-1 do Write(Lst,Char(Pap[n]^[(2*i+1)*xxx+j]));
      Writeln(Lst,#27,'j',#2); {2/216 Up}
      If KeyPressed then c:=ReadKey;
      If c=' ' then Begin Repeat Until KeyPressed; c:=ReadKey; c:='_';End;
      Inc(i);
    End;
    i:=0;Inc(n);
  End;
End;

Procedure PrintPaper3;
Var n,i,j,k,s:Word; Maxn:Byte;
    c:Char;
Begin
  Write(Lst,#27'A'#8#27'2'); {⠭ ࢠ}
  Write(Lst,#27,'5',#0); {⪫祭 ⮯ॢ ப}
  n:=0; i:=0; c:='_'; Maxn:=(yyy-1) div 16;
  While (n<=5)and(c<>#27)and(n*nPlan+i<=Maxn) do Begin
    While (i<=NPlan-1)and(c<>#27)and(n*nPlan+i<=Maxn) do Begin
      Write(Lst,#27'*'#3,Char(xxx mod 256),Char(xxx div 256)); {Gr. reg.}
      For j:=0 to xxx-1 do Write(Lst,Char(Pap[n]^[i*xxx*2+j]));
      Write(Lst,#27,'J',#2,#13);  {2/216 + <CR> }
      Write(Lst,#27'*'#3,Char(xxx mod 256),Char(xxx div 256)); {Gr. reg.}
      For j:=0 to xxx-1 do Write(Lst,Char(Pap[n]^[(2*i+1)*xxx+j]));
      Writeln(Lst,#27,'j',#2); {2/216 Up}
      If KeyPressed then c:=ReadKey;
      If c=' ' then Begin Repeat Until KeyPressed; c:=ReadKey; c:='_';End;
      Inc(i);
    End;
    i:=0;Inc(n);
  End;
End;

Procedure PrintPaper144;
Var n,i,j,k,s:Word; Maxn:Byte;
    c:Char;
Begin
  Write(Lst,#27'A'#8#27'2'); {⠭ ࢠ}
  Write(Lst,#27,'5',#0); {⪫祭 ⮯ॢ ப}
  n:=0; i:=0; c:='_'; Maxn:=(yyy-1) div 16;
  While (n<=5)and(c<>#27)and(n*nPlan+i<=Maxn) do Begin
    While (i<=NPlan-1)and(c<>#27)and(n*nPlan+i<=Maxn) do Begin
      Write(Lst,#27'*'#7,Char(xxx mod 256),Char(xxx div 256)); {Gr. reg.}
      For j:=0 to xxx-1 do Write(Lst,Char(Pap[n]^[i*xxx*2+j]));
      Write(Lst,#27,'J',#2,#13);  {2/216 + <CR> }
      Write(Lst,#27'*'#7,Char(xxx mod 256),Char(xxx div 256)); {Gr. reg.}
      For j:=0 to xxx-1 do Write(Lst,Char(Pap[n]^[(2*i+1)*xxx+j]));
      Writeln(Lst,#27,'j',#2); {2/216 Up}
      If KeyPressed then c:=ReadKey;
      If c=' ' then Begin Repeat Until KeyPressed; c:=ReadKey; c:='_';End;
      Inc(i);
    End;
    i:=0;Inc(n);
  End;
End;

Procedure PrintPaper4;
Var i,j,k,s,tn,tx,txx:Word;c:Char;
Begin
  txx:=xxx-2;
  tn:=yyy div 24;
  Write(Lst,#27'A'#8#27'2'); {⠭ ࢠ}
  Write(Lst,#27,'5',#0); {⪫祭 ⮯ॢ ப}
  i:=0;
  While (i<=tn)and(c<>#27) do Begin
      Write(Lst,#27'*'#3,Char(txx mod 256),Char(txx div 256)); {Gr. reg.}
      For k:=0 to txx-1 do Begin
          s:=0;
          For j:=0 to 7 do
              s:=(s shl 1)+GetDot(k,(j+i*8)*3);
          Write(Lst,Char(s));
      End;
      Write(Lst,#27,'J',#1,#13);  {1/216 + <CR> }
      Write(Lst,#27'*'#3,Char(txx mod 256),Char(txx div 256)); {Gr. Reg.}
      For k:=0 to txx-1 do Begin
          s:=0;
          For j:=0 to 7 do
              s:=(s shl 1)+GetDot(k,(j+i*8)*3+1);
          Write(Lst,Char(s));
      End;
      Write(Lst,#27,'J',#1,#13);  {1/216 + <CR> }
      Write(Lst,#27'*'#3,Char(txx mod 256),Char(txx div 256)); {Gr. Reg.}
      For k:=0 to txx-1 do Begin
          s:=0;
          For j:=0 to 7 do
              s:=(s shl 1)+GetDot(k,(j+i*8)*3+2);
          Write(Lst,Char(s));
      End;
      Write(Lst,#27,'J',#22,#13); {2/216 +<CR>}
      If KeyPressed then c:=ReadKey;
      If c=' ' then Begin Repeat Until KeyPressed; c:=ReadKey; c:='_';End;
      Inc(i);
  End;
End;

Procedure PrintPaper;
Begin
  Case Res of
   1:PrintPaper1;
   2:PrintPaper2;
   3:PrintPaper3;
   4:PrintPaper4;
  End;
End;

Procedure InitPaper;
Begin
For i:=0 to NPiece do
  If MaxAvail<32768 then Begin
     Writeln('PAPER -- Sorry. You have not enough memory.');
     Halt(2);
  End else New(Pap[i]);
End;

Procedure DonePaper;
Begin
  For i:=0 to NPiece do Dispose(Pap[i]);
End;

Procedure ClearPaper;
Var n:Byte;j:Word;
Begin
  For n:=0 to NPiece do
    For j:=0 to 32767 do Pap[n]^[j]:=0;
End;

Procedure ChoosePaper(n:Byte);
Begin
   SizeX:=Papers[n].x;
   SizeY:=Papers[n].y;
   xxx:=Trunc(Papers[n].x/inch*px);
   yyy:=Trunc((Papers[n].y-dy)/inch*py);
   NPlan:=Trunc(16384/xxx);
   SetDefPrintPort;
End;

Procedure SelectPaper(x,y:Real);
Begin
   SizeX:=x;SizeY:=y;
   xxx:=Trunc(x/inch*px);
   yyy:=Trunc((y-dy)/inch*py);
   NPlan:=Trunc(16384/xxx);
   SetDefPrintPort;
End;

Procedure ChooseRes(n:Byte); {襭}
Begin
   Case n of
    1:Begin px:=60; py:=72; Res:=1; NPiece:=3; End;
    2:Begin px:=120; py:=144; Res:=2; NPiece:=6; End;
    4:Begin px:=240; py:=216; Res:=4; NPiece:=19; End;
    else Begin px:=240; py:=144; Res:=3; NPiece:=12; End;
   End;
End;


Procedure Bar(x1,y1,x2,y2:Integer);
Var i,j,ax,bx,ay,by:Integer;
Begin
  ax:=Min(x1,x2); ay:=Min(y1,y2);
  bx:=Max(x1,x2); by:=Max(y1,y2);
  For i:=ax to bx do
      For j:=ay to by do PutPixel(i,j,cCol);
End;

Procedure Rectangle(x1,y1,x2,y2:Integer);
Begin
  Line(x1,y1,x1,y2);Line(x2,y1,x2,y2);
  Line(x1,y1,x2,y1);Line(x1,y2,x2,y2);
End;

Procedure LineS(x1,y1,x2,y2:Integer);
Var
	i,j,sx,sy,x,y,xx,yy:Integer;
	dx,dy,s,n:Real;
Function Sign(x:Integer):Integer;
Begin
  If x>0 then Sign:=1
         else If x=0 then Sign:=0
                     else Sign:=-1;
End;

Begin
	x:=x2-x1;y:=y2-y1;
	sx:=Sign(x);sy:=Sign(y);
	x:=x+sx;y:=y+sy;
	xx:=Abs(x);yy:=Abs(y);
	If (xx=0)or(yy=0) then Bar(x1,y1,x2,y2)
	else Begin
	If xx>yy
	then Begin
		dx:=xx/yy*sx;s:=x1;n:=x1-sx;
		Repeat
			n:=n+dx;
			Bar(Trunc(s),y1,Trunc(n),y1);
			y1:=y1+sy;s:=n+sx;
		Until y1=y2+sy;
	End
	else Begin
		dy:=yy/xx*sy;s:=y1;n:=y1-sy;
		Repeat
			n:=n+dy;
			Bar(x1,Trunc(s),x1,Trunc(n));
			x1:=x1+sx;s:=n+sy;
		Until x1=x2+sx;
	End;
	PutPixel(x2,y2,cCol);
	End;
End;

Procedure Line(x1,y1,x2,y2:Integer);
Var i,j:ShortInt;
Begin
  For i:=-Trunc(Thick/2) to Trunc((Thick+1)/2) do
   For j:=-Trunc(Thick/2) to Trunc((Thick+1)/2) do
    LineS(x1+i,y1+j,x2+i,y2+j);
End;

Procedure MoveTo(x,y:Integer);
Begin
  PPx:=x; PPy:=y;
End;

Procedure MoveRel(x,y:Integer);
Begin
  PPx:=PPx+x; PPy:=PPy+y;
End;

Procedure LineTo(x,y:Integer);
Begin
 Line(PPx,PPy,x,y);
 PPx:=x; PPy:=y;
End;

Procedure LineRel(x,y:Integer);
Begin
 Line(PPx,PPy,PPx+x,PPy+y);
 PPx:=PPx+x; PPy:=PPy+y;
End;


Function Cx(x:Real):Integer;
Begin
  Cx:=Trunc(x/SizeX*xxx);
End;
Function Cy(Y:Real):Integer;
Begin
  Cy:=Trunc(y/(SizeY-dy)*yyy);
End;

Procedure PutPixelM(x,y:Real;c:Byte);
Begin
  PutPixel(Cx(x),Cy(y),c);
End;
Procedure BarM(x1,y1,x2,y2:Real);
Begin
  Bar(Cx(x1),Cy(y1),Cx(x2),Cy(y2));
End;
Procedure RectangleM(x1,y1,x2,y2:Real);
Begin
  Rectangle(Cx(x1),Cy(y1),Cx(x2),Cy(y2));
End;
Procedure LineM(x1,y1,x2,y2:Real);
Begin
  Line(Cx(x1),Cy(y1),Cx(x2),Cy(y2));
End;
Procedure LineToM(x,y:Real);
Begin
  LineTo(Cx(x),Cy(y));
End;
Procedure LineRelM(x,y:Real);
Begin
  LineRel(Cx(x),Cy(y));
End;
Procedure MoveToM(x,y:Real);
Begin
  MoveTo(Cx(x),Cy(y));
End;
Procedure MoveRelM(x,y:Real);
Begin
  MoveRel(Cx(x),Cy(y));
End;

Procedure SetThick(n:Byte);
Begin Thick:=n; End;

Function GetX:Integer;
Begin GetX:=PPx; End;

Function GetY:Integer;
Begin GetY:=PPy; End;

Function GetMaxX:Integer;
Begin GetMaxX:=xxx; End;

Function GetMaxY:Integer;
Begin GetMaxY:=yyy; End;

Function GetSizeX:Real;
Begin GetSizeX:=SizeX; End;

Function GetSizeY:Real;
Begin GetSizeY:=SizeY; End;

Procedure SetPrintPort(x1,y1,x2,y2:Integer);
Begin
  oUp:=Min(y1,y2); oDn:=Max(y1,y2);
  oLt:=Min(x1,x2); oRt:=Max(x1,x2);
End;
Procedure SetPrintPortM(x1,y1,x2,y2:Real);
Begin
  SetPrintPort(Cx(x1),Cy(y1),Cx(x2),Cy(y2));
End;

Procedure SetDefPrintPort;
Begin
   SetPrintPort(0,0,GetMaxX,GetMaxY);
End;

Function GetPortX:Integer;
Begin GetPortX:=oRt-oLt; End;

Function GetPortY:Integer;
Begin GetPortY:=oDn-oUp; End;

Procedure SetColor(c:Byte);
Begin cCol:=c; End;

Function GetColor:Byte;
Begin GetColor:=cCol; End;

Begin
  SetThick(0);
  SetColor(1);
  PPx:=0; PPy:=0;
  For i:=0 to MaxPiece do Pap[i]:=Nil;
End.