Var { Consts }
    KPw,KPt,KSw,KMt,KMc,KMw,KOwop,KOwom,KCc :Arr2;
    KPii,KPm,KPsp,KPsm,KPo,KPe,KPp,KPl,KPc,
    KSii,
    KMii,KMo,KMl,KMp,
    KOm,KOt1,KOt2,KOc1,KOc2,
    KLo,KLc,
    P0,O0,O1 :Arr;

Function ddP(i:Byte):Real; far;

                               {Passionarians}

Var Pii,Pm,Psp,Po,Pw,Pe,Pp,Psm,Pl,Pc,Pt,Pmp:Real;
    j:Byte;
Begin
  Pii:=KPii[i]*Imp(i);                               {Passionarian stimulus}
  Pm:=KPm[i]*Xi(Sign(odP[i]))*Xi(P[i]-P0[i])*M[i];   {+Influence of harm. people}
  Psp:=KPsp[i]*Xi(Sign(odP[i]))*Xi(P[i]-P0[i])*S[i]; {+Influence of subpass-ns }
  Psm:=KPsm[i]*Xi(t-LimT)*Xi(P0[i]-P[i])*S[i];       {Philistine}
  Po:=KPo[i]*Xi(KPo[i])*Xi(P[i])*P[i];               {Creating the State}
  Pw:=0; For j:=1 to mm do If (i<>j)and War(i,j) then Pw:=Pw+KPw[i,j]*P[i];
                                                     {Casualties} 
  Pe:=KPe[i]*Dict(i)*P[i];                           {-Migrations}
  Pp:=KPp[i]*(1-exp(-0.03*t))*P[i];                  {Internecine struggle} 
  Pl:=KPl[i]*P[i];                                   {Transforming the landscape}
  Pt:=0;
  For j:=1 to mm do Begin
    Pt:=Pt+KPt[i,j];                        	     {Science}
  End;
  Pt:=Pt*P[i];
  Pc:=KPc[i]*P[i];                          	     {Art}
{  Pmp:=KMp[i]*M[i]*t/(60000+Sqr(t)/90);}

  ddP:= 0.005*P[i]+Pii+Pm+Psp-Po-Pw-Pe-Pp-Psm-Pl-Pc-Pt;
{+Pmp}
End;

Function ddS(i:Byte):Real; far;

                              {Subpassionarians}

Var Sii,Sp,Sw,Som,Sot,Soc:Real;
    j:Byte;
Begin
  Sii:=KSii[i]*Imp(i);
  Sp:=KPsp[i]*Xi(Sign(odP[i]))*S[i];
  Sw:=0; For j:=1 to mm do If (i<>j)and War(i,j) then Sw:=Sw+KSw[i,j]*S[i];
{  Som:=KOm[i]*Xi(O[i]-O1[i])*Xi(t-LimT)*O[i];}
{  Sot:=KOt2[i]*Dict(i)*O[i];}
{  Soc:=KOc2[i]*Dict(i)*O[i];}

  ddS:=Sii-Sp-Sw+0.005*Xi(t-LimT)*M[i];
{+Som+Sot+Soc}
End;

Function ddM(i:Byte):Real; far;

                         {Harmonic people}

Var Mii,Mtc,Mp,Mw,Mo,Ml,Mpp:Real;
    j:Byte;
Begin
  Mii:=KMii[i]*Imp(i);
  Mtc:=0; For j:=1 to mm do Mtc:=Mtc+KMt[i,j]*D[j]+KMc[i,j]*C[j];
  Mp:=KPm[i]*Xi(Sign(odP[i]))*M[i];
  Mo:=KMo[i]*Xi(O0[i]-O[i])*Xi(LimT-t)*M[i];
  Mw:=0; For j:=1 to mm do If (i<>j)and War(i,j) then Mw:=Mw+KMw[i,j]*M[i];
  Ml:=KMl[i]*M[i];
{  Mpp:=KMp[i]*M[i]*t/(70000+Sqr(t)/70);}

  ddM:=Mii+Mtc-Mp-Mw-Mo-Ml- 0.01*Xi(t-LimT)*M[i];
{-Mpp}
End;

Function ddO(i:Byte):Real; far;

                     {Organization (State)}

Var Op,Omp,Owp,Owm,Owop,Ol,Owom,Omm,Ot1,Oc1,Ot2,Oc2:Real;
    j:Byte;
Begin
  Op:=KPo[i]*Xi(KPo[i])*Xi(P[i])*P[i];
  Omp:=KMo[i]*Xi(O0[i]-O[i])*Xi(LimT-t)*M[i];
  Owp:=0; Owm:=0; Owop:=0; Owom:=0;
  For j:=1 to mm do If (i<>j)and War(i,j) then Begin
      Owp:=Owp+KPw[i,j]*P[i];
      Owm:=Owm+KSw[i,j]*S[i]+KMw[i,j]*M[i];
      Owop:=Owop+KOwop[i,j]*Xi(M[i]-M[j])*Xi(P[i]-P[j])*Xi(O[i]-O[j])*Xi(D[i]-D[j])*O[j];
      Owom:=Owom+KOwom[i,j]*Xi(M[j]-M[i])*Xi(P[j]-P[i])*Xi(O[j]-O[i])*Xi(D[j]-D[i])*O[i];
  End;
  Omm:=KOm[i]*Xi(O[i]-O1[i])*Xi(t-LimT)*O[i];
  Ol:=KLo[i]*L[i];
  Ot1:=KOt1[i]*Xi(O[i]-O1[i])*O[i];
  Ot2:=KOt2[i]*Dict(i)*O[i];
  Oc1:=KOc1[i]*O[i]; {-}
  Oc2:=KOc2[i]*Dict(i)*O[i];

  ddO:=Op+Omp+Owp+Owm+Owop+Ol-Owom-Omm-Ot1-Oc1-Ot2-Oc2;
End;

Function ddT(i:Byte):Real; far;

                          {Science}

Var Tp,Top,Tom,Tm:Real;
    j:Byte;
Begin
  Tp:=0; Tm:=0;
  For j:=1 to mm do Begin
      Tp:=Tp+KPt[j,i]*P[j];
      Tm:=Tm+KMt[i,j];
  End;
  Tm:=Tm*D[i];
  Top:=KOt1[i]*Xi(O[i]-O1[i])*O[i];
  Tom:=KOt2[i]*Dict(i)*O[i];

  ddT:=Tp+Top-Tom-Tm;
End;

Function ddC(i:Byte):Real; far;

                           {Art & Culture}

Var Cp,Ccp,Ccm,Cop,Cl,Com,Cm:Real;
    j:Byte;
Begin
  Cp:=KPc[i]*P[i];
  Ccp:=0; Ccm:=0; Cm:=0;
  For j:=1 to mm do Begin
   If i<>j then Ccm:=Ccm+KCc[i,j]*C[i];
   If i<>j then
     Ccp:=Ccp+KCc[j,i]*C[j];
   Cm:=Cm+KMc[i,j];
  End;
  Ccp:=Ccp*(1-Xi(Sign(odP[i])))*Xi(P[i]-P0[i])*Xi(t-LimT);
  Cm:=Cm*C[i];
  Cop:=KOc1[i]*O[i];
  Com:=KOc2[i]*Dict(i)*O[i];
  Cl:=KLc[i]*L[i];

  ddC:=Cp+Ccp+Cop+Cl-Com-Cm-Ccm;
End;

Function ddL(i:Byte):Real; far;

                               {Landscape}

Var Lp,Lm,Lo,Lc:Real;
    j:Byte;
Begin
  Lp:=KPl[i]*P[i];
  Lm:=KMl[i]*M[i];
  Lo:=KLo[i]*L[i];
  Lc:=KLc[i]*L[i];

  ddL:=Lp+Lm-Lo-Lc;
End;
